#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

extern "C" {
#include <values.h>
#include <math.h>
#include <float.h>

#ifndef MAXINT
#define MAXINT int(~(1U<<(8*sizeof(int))-1))
#endif
#undef MININT
#define MININT (-MAXINT)

#undef MAXDOUBLE
#ifdef DBL_MAX
#define MAXDOUBLE DBL_MAX
#endif
#ifndef DBL_MAX
#define MAXDOUBLE  1.7976931348623157e+308  
#endif

#ifndef M_PI
#define M_PI 	3.14159265358979323846
#endif

}

#endif
