#ifndef __EVENT_H__
#define __EVENT_H__

#include "position.h"

enum ButtonType { ButtonSelect,ButtonCreate,ButtonUser };
enum EventType { EventInit,EventDouble,EventMotion,EventQuickExit,EventExit };

struct EventInfo
{
	Position pos;
	ButtonType button;
	EventType event;
	bool shift;
	EventInfo(Position p,ButtonType b,EventType e,bool s):
		pos(p),button(b),event(e),shift(s) {}
	EventInfo() {}
};

#endif

