#ifndef __NODECL_H__
#define __NODECL_H__

#include "objcl.h"
#include "position.h"

class Node;
class Net;
class NetClass;

class NodeClass;
class NodeClass: public ObjectClass
{
	NetClass* subclass;
	bool align;
	friend class NetClass;
	NodeClass(NetClass& nt);

public:
	void DrawButton(Display* dpy,Drawable d,int x,int y,int w,int h);
	
	bool SubstitutionNode() { return subclass!=0; }
	bool Align() { return align; }
	NetClass* SubClass() { return subclass; }
	bool IsNodeClass() { return true; }
	Position PointToMid(ShapeData& sd,Position& ps);
	
	istream& Input(istream&);
};

typedef NodeClass *NodeClassP;

#endif
