#ifndef __TOOL_H__
#define __TOOL_H__

#include "xbefore.h"
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include "xafter.h"

extern "C++" {
extern int Maxi(int a,int b);
extern int Mini(int a,int b);
extern void SetStringValue(Widget w,char *res,char *msg);
extern char* GetStringValue(Widget w,char *res);
extern char* NormalString(XmString cs);
extern void _FixHighlight(Widget scw);
extern void CheckLabelPixmap(Widget w);
extern void CatchDestroy(Widget* w1,Widget* w2 = 0,Widget* w3 = 0,Widget* w4 = 0);
extern void UncatchDestroy(Widget* w1,Widget* w2 = 0,Widget* w3 = 0,Widget* w4 = 0);
}

#endif
