// File     pong.cpp      (C++ Implementation)
/**
 *          ping/pong Bandwidth measuring tool
 *
 *@author   Philipp Berndt
 *@version  $Id: pong.cpp,v 1.2 2000/01/12 16:02:02 pumphutt Exp $
 */

#include "pvm3cpp.h"

int main()
{
    pvm_mytid();

    while (true)
        {
        pvm_recv(-1,-1);
        int times = pvm_upkint();
        int n = pvm_upkint();
        double* b = new double[n];

        for(int i=0;i<times;++i)
            {
            int bufid, bytes, msgtag, tid;
            bufid = pvm_recv(-1, -1);
            pvm_bufinfo(bufid, &bytes, &msgtag, &tid);
            pvm_upkdouble(b,n,1);

            pvm_initsend(PvmDataInPlace);
            pvm_pkdouble(b, n, 1);
            pvm_send(tid, 0);
            }
        }
}
            
