/*macro for AdjWCount = 2*/
r0 = ~AdjBitRow[0]; /*contains (Sat->V[rminus] OR Sat->V[rplus]) */
r1 = ~AdjBitRow[1];
r2 = ~AdjBitRow[2];

#ifdef USEFASTSAT
for (otherRay = 0; otherRay<rowcount;) 
{
  if(r0 & FastSat[otherRay])
    {
      otherRay+=3;
      continue;
    }
  if(r1 & FastSat[otherRay+1])
    {
      otherRay+=3;
      continue;
    }
 if(r2 & FastSat[otherRay+2])
    {
      otherRay+=3;
      continue;
    }
  else
    {
#ifdef SHOWTIME	
      seekray += seek;
#endif
      goto is_redundant;
    }
}
#endif

//otherRay = TTEST +2;
#ifdef USEFASTSAT
otherRay += rowcount / 3;
#endif

for (otherRay=low_bound1+2; otherRay<NbRay; otherRay++) 
     /*for (otherRay = NbRay-1; otherRay>=TTEST+2; otherRay--) */
     /*for each ray otherRay, otherRay!=rplus, otherRay!=rminus do*/  
{
#ifdef SHOWTIME	
  seek++;
#endif
  /* (r+ r-) is redundant if there does NOT exist an equation */
  /* which saturates both r+ and r- but not otherRay */
  
  ptr2 = Sat->V[otherRay];
  
  if (*ptr2&r0) continue;
  ptr2++;
  if (*ptr2&r1) continue;
  ptr2++;
  if (*ptr2&r2) continue;
  else
    {
#ifdef SHOWTIME	
      seekray += seek;
#endif
      
      goto is_redundant;
    }
}  /*for (otherRay*/

for (otherRay=TTEST+2; otherRay<low_bound1+2; otherRay++) 
     /*for (otherRay = NbRay-1; otherRay>=TTEST+2; otherRay--) */
     /*for each ray otherRay, otherRay!=rplus, otherRay!=rminus do*/  
{
#ifdef SHOWTIME	
  seek++;
#endif
  /* (r+ r-) is redundant if there does NOT exist an equation */
  /* which saturates both r+ and r- but not otherRay */
  
  ptr2 = Sat->V[otherRay];
  
  if (*ptr2&r0) continue;
  ptr2++;
  if (*ptr2&r1) continue;
  ptr2++;
  if (*ptr2&r2) continue;
  else
    {
#ifdef SHOWTIME	
      seekray += seek;
#endif
      
      goto is_redundant;
    }
}  /*for (otherRay*/
