#ifndef __ESTIMATE_H__
#define __ESTIMATE_H__
#include "matrix.h"
/*estimate the state space from state equation*/
int EstimateStateEq(INTMATRIX *M, INTMATRIX *IncidenceMat);

/*estimate the state space from state equation with backtracking*/
int EstimateBackTr(INTMATRIX *_M, INTMATRIX *_IncidenceMat, INTMATRIX *_PostMat, int level);

/*estimate the state space from state equation + traps/siphons*/
int EstimateTrapSiphon( INTMATRIX *_M, INTMATRIX *_IncidenceMat, INTMATRIX *_PostMat, INTMATRIX *_PreMat);

#endif
