#include "matrix.h"
#include "lists.h"
/*global variables*/

INTMATRIX *Ray; /*rays*/
INTMATRIX *Sat; /*saturation bit-matrix : BITi=0 means Ai.x =0, BITi=1 means Ai.x!=0 for Constraint Ai*/
INTMATRIX *MinF;/*minimum infeasible index: MinF[i] = Index of first constraint for which A.RAYi<0*/
INTMATRIX *IndexLR; /*translate ray-index from LinkedList to Ray*/
INTMATRIX *IndexRL; /*translate ray-index from Ray to LinkedList*/
INTMATRIX *Constraints;/*Constraints*/
LiList **LiListArray;/*Array for the linked lists*/
LiList *GenList;/*store the index of the feasible generator of a new ray and the index of the new ray*/
FreeLi *FLR; /*free entrys in the index list*/
USI blockflag = 1; /*=0 if there are single rows to be filled*/
/*=1 if there are no single rows : allocate a new memory block for new rows*/
USI NbIndexLR; /*last used Element in IndexLR*/
USI NbIndexRL;
USI NbRay; /*last used Element in Ray*/
USI NbLines; /*number of Lines */
USI OldRays; /*for debugging output only*/
USI NbMaxRays = 500000;
USI NbConstraints; /*number of constraints*/
USI Dimension; /*homogenous Dimension*/
USI nc;
USI WCount, BCount;
USI AdjWCount, AdjBCount, AdjBitmask; /*needed by adjacency test*/
int *AdjBitRow,*BitRow, *BitRow2, *BitRow3;
int *raytemprow, *sattemprow,*minftemprow;
int *Border;
int *LookUpMat;
USI TTEST;
USI anztest=0, checkedlater=0, secondpart=0;
USI adjcounter = 0, redcounter = 0, quickcounter=0;
USI seekray = 0, seek = 0;
USI totaltests = 0;       
int maxMinF;
