#include "struct_types.h"
#include "netio.h"

		/******* global variables *******/

int no_places;			/* number of places in the net */
int no_trans;			/* number of transitions in the net */
int no_md_arcs;			/* number of marking dependent arcs */
int no_timed_trans;		/* number of timed transitions */
int no_pinvar;			/* number of place-invariants */
int no_subnets;			/* number of subnets */
int row_width;			/* width of one algorithm-row, = no_places + no_trans */

sp_place 	**i_matrix, **o_matrix, **c_matrix;	/* in, out and c-matrix */
sp_place 	**h_matrix;			/* inhibitor matrix */
md_arc		*md_arcs;			/* marking dep. arcs */
pinvar 		*pinvars;			/* resulting P-invariants */
subnet		*subnets;			/* immediate transition subnets */
name_nr		*m_par;				/* marking parameters */
name_delay	*r_par;				/* real parameters */
place		*places;			/* place description */
transition  	*transitions;			/* transition description */
FILE 		*struct_file, *inf_file;	/* input and output files */
int		pin_bit=0, subnet_bit=0, ecs_bit=0;	/* options for output of results */
int		conf_bit=0;			/* ignore confusions option */
int		pmf_bit=0;			/* generate pmf file */


