/*******************************************************************/
/* Patrick Drescher                        Matr.: 136106           */
/* Illigstr. 56a                                                   */
/* 12307 Berlin                                                    */
/* Tel.: 7452384                                                   */
/*******************************************************************/
/*                                                                 */
/*                         RESTART MODUL                           */
/*                                                                 */
/*******************************************************************/

/*************/
/* set_rst.c */
/*************/

#include <stdio.h>
#include <ctype.h>
#include <math.h>

#define MAX_THRESHOLDS 30
#define MAX_PRE_PROBS 50
#define e_minus_2 0.1353352832

int        max_no_thresholds,
           go_out,
           no_opt_thresholds,
           t_value[MAX_THRESHOLDS+1],
           retrials[MAX_THRESHOLDS+1],
           param[5],
           border,
           z_max,
           direction,
           event,
           no_thresholds,
           no_ok,
           ok[MAX_PRE_PROBS+1],
           z[MAX_PRE_PROBS+1],
           m[MAX_PRE_PROBS+1],
           z_count,
           z_last,
           n,
           i,
           l,
           h;
float      p_r[MAX_PRE_PROBS+1],
           p_z[MAX_PRE_PROBS+1],
           prob[MAX_THRESHOLDS+1],
           p[MAX_THRESHOLDS+1],
           p_i_now,
           diff_min,
           k;
char       *param_string[]={"measure_place","direction","event","z_max","border"},
           *help_string[]={"z","Mean Value ="},
           *pointer,
           measure_place[100],
           string[100],
           param_file[256],
           result_file[256],  
           *fgets(),
           *strrchr();
FILE       *filepointer,
           *fopen();

main(argc, argv)
int argc;
char *argv[];

{

if (argc!=3)
   {
   fprintf(stderr,"wrong number of parameters\n");
   exit(1);
   }

sprintf(param_file,"%s.PARAM",argv[1]);
sprintf(result_file,"%s_RST.RESULTS",argv[1]);

if ((max_no_thresholds=atoi(argv[2]))>MAX_THRESHOLDS)
   max_no_thresholds=MAX_THRESHOLDS;

if ((filepointer=fopen(param_file,"r"))==NULL)
   {
   fprintf(stderr,"cannot open %s\n",param_file);
   exit(1);
   }
for (i=0;i<=4;++i)
   if (fgets(string,100,filepointer)==NULL)
      {
      fprintf(stderr,"cannot read %s\n",param_string[i]);
      exit(1);
      }
   else
      if (!strncmp(string,param_string[i],strlen(param_string[i])))
         if (i==0)
   	    {
            pointer=string+strlen(param_string[i])+3;
            l=0;        
            while ((*pointer!='\n')&&(!isspace(*pointer)))
               {
               measure_place[l]=*pointer;
               ++pointer, ++l;
	       }
            measure_place[l]='\0';               
            }
         else 
            param[i]=atoi(strrchr(string,'=')+1);
      else
         {
         fprintf(stderr,"cannot read %s\n",param_string[i]);
	 exit(1);
         }
close(filepointer);

direction=param[1];
event=param[2];
z_max=param[3];
border=param[4];


/* extract values from _RST.RESULTS */

if ((filepointer=fopen(result_file,"r"))==NULL)
   {
   fprintf(stderr,"cannot open %s\n",result_file);
   exit(1);
   }
for (z_count=1; z_count<=z_max; ++z_count)
    for (n=0; n<2; ++n)
        {
        do {
           if (fgets(string,100,filepointer)==NULL)
              {
              fprintf(stderr,"cannot read %-d. value\n",z_count);
	      exit(1);
              }
           pointer=string;
           while (isspace(*pointer))
              ++pointer;
           } while (strncmp(pointer,help_string[n],strlen(help_string[n])));
        pointer+=strlen(help_string[n]);
        switch (n)
           {
           case 0:
              z[z_count]=atoi(pointer);
              break;
           case 1:
              if ((strncmp(pointer," NaN",4))&&((float)atof(pointer)!=0.0))
		 {
                 ok[z_count]=1;
		 p_r[z_count]=(float)atof(pointer);
	         }
              else
                 ok[z_count]=0;
              break;
           default:
              break;
           }
        }
fclose(filepointer);

/* set thresholds */

no_opt_thresholds=0;
for (z_count=1, no_ok=0; z_count<=z_max; ++z_count)
    if (ok[z_count])
       {
       ++no_ok, m[no_ok]=z[z_count], p_z[no_ok]=p_r[z_count];
/*       fprintf(stdout,"%3d   %d   %e\n",no_ok,m[no_ok],p_z[no_ok]);*/
       }
if (no_ok>0)
   z_count=1, i=0, z_last=0, p_z[0]=1;
else
   {
   i=0,z_count=0,m[0]=border;
   linear_setting();
   write_values();
   exit(0);
   }
do {
   ++i, diff_min=1.0, go_out=0;
   do {
      p_i_now=p_z[z_count]/p_z[z_last];
      if (((float)fabs(p_i_now-e_minus_2)<diff_min)||((p_i_now-e_minus_2)>0))
         diff_min=(float)fabs(p_i_now-e_minus_2), t_value[i]=m[z_count], p[i]=p_i_now;
      else
         {
         ++no_opt_thresholds;
         if (i>1)
            if (1/sqrt(p[i]*p[i-1])-(int)(1/sqrt(p[i]*p[i-1]))<0.5)
               retrials[i-1]=(int)(1/sqrt(p[i]*p[i-1]));
            else
               retrials[i-1]=(int)(1/sqrt(p[i]*p[i-1])+1); 
         z_last=z_count-1;
         prob[i]=p_z[z_last];
         go_out=1;
         }
      if ((!go_out)&&(z_count==no_ok))
         {
         if (i>1)
            if (1/sqrt(p[i]*p[i-1])-(int)(1/sqrt(p[i]*p[i-1]))<0.5)
               retrials[i-1]=(int)(1/sqrt(p[i]*p[i-1]));
            else
               retrials[i-1]=(int)(1/sqrt(p[i]*p[i-1])+1);
         retrials[i]=7;
         linear_setting();
         write_values();
	 exit(0);
         }
      if (!go_out)
         ++z_count;
      } while (!go_out);
   } while (i<max_no_thresholds);
retrials[i]=7, no_thresholds=i;
write_values();
exit(0);
}


linear_setting()
{
if (direction==1 ? (i<max_no_thresholds)&&(m[z_count]+1<event) 
                 : (i<max_no_thresholds)&&(m[z_count]-1>event))
   n=m[z_count];
else
   {
   no_thresholds=i;
   return;
   }
if (direction==1 ? (event-n-1)<=(max_no_thresholds-i)
                 : (n-event-1)<=(max_no_thresholds-i))
   {
   do {
      ++i, n+=direction, t_value[i]=n, retrials[i]=7;
      } while (n+direction!=event);
   no_thresholds=i;
   }
else
   {
   k= direction==1 ? (float)(event-n)/(float)(1+max_no_thresholds-i)
                   : (float)(n-event)/(float)(1+max_no_thresholds-i);
   for (l=1, h=0; i<max_no_thresholds; ++l)
       if ((((float)l/k-(float)h)>=1.0))
          ++h, ++i, t_value[i]=n+direction*l, retrials[i]=7;
   no_thresholds=i;
   }
}


write_values()
{
/* write .PARAM file */

if ((filepointer=fopen(param_file,"w"))==NULL)
   {
   fprintf(stderr,"cannot open %s\n",param_file);
   exit(1);
   }

fprintf(filepointer,"measure_place = %s\n",measure_place);
fprintf(filepointer,"direction = %-d\n",direction);
fprintf(filepointer,"event = %-d\n",event);
fprintf(filepointer,"border = %-d\n",border);
fprintf(filepointer,"no_thresholds = %-d\n",no_thresholds);
fprintf(filepointer,"no_opt_thresholds = %-d\n",no_opt_thresholds);
for (i=1; i<=no_thresholds; ++i)
    {
    fprintf(filepointer,"t_value[%-d] = %-d\n",i,t_value[i]);
    fprintf(filepointer,"retrials[%-d] = %-d\n",i,retrials[i]);
    }
for (i=1;i<=no_opt_thresholds; ++i)
    fprintf(filepointer,"prob_opt[%-d] = %g\n",i,prob[i]);
fclose(filepointer);
}


