#ifndef __CODE_H__
#define __CODE_H__

#include "value.h"
#include "text.h"
#include "wrapper.h"
#include "keytable.h"

#define TABWIDTH 2

class Code;
class Code: public Text, public Wrapper<Code,int>
{
protected:
  Widget CreateWidget(Widget parent);
  void Validate(Widget, int, XtPointer calldata);
  void Highlight(Widget, int, XtPointer);
public:
  Code(NetClass* nc = 0,bool hidden = false);
  Code(const char* s);
  Code(const Code& t);
  Value* Copy() const { return new Code(*this); }
  Value* Cast() const { return Copy(); }
};

typedef Code* CodeP;

#endif
