#include "xbefore.h"
#include <Xm/Text.h>
#include <Xm/ScrolledW.h>
#include "xafter.h"

#include <iostream.h>
#include "logwin.h"
extern "C" {
#include <fcntl.h>
}
Widget scroll;

bool LogWindow::Timer(bool)
{
	char buf[520]; bool update = false;
	
	istr.clear();
	do
	{
		char c,* p=buf;
    while (p-buf<512 && istr.get(c)) {
      if (!OnRecieveChar(c))
        *p++=c;
      if (c=='\n') break;
    }

		*p = 0;
		if (p > buf) update = true;
		text += (p = buf);
	}
	while (istr);
	
 	//AH Changed Start to_bool() to_charPtr()
 	if (update && w && text.to_bool())
	  {
 		XmTextSetString(w,text.to_charPtr());
 		//AH Changed End

		if (auto_scroll_down)
		  {
		    XmTextPosition pos= 65535;
		    XmTextShowPosition(w,pos);
		    // bottom_position des Textes anzeigen!!!
		  }
	  }
	
 	//AH Changed Start => & LogWindow::
 	input_id = wrapper.InputCB(fd,XtInputReadMask,&LogWindow::Input,false);
 	//AH Changed End
	timer_id = 0;
	return false;	// nicht fortsetzen
}

	
bool LogWindow::Input(int,bool)
{
//	cout<<"Input!"<<endl;
	
	if (timer_id) wrapper.RemoveCB(timer_id);
 	//AH Changed Start => & LogWindow::
 	timer_id = wrapper.TimerCB(input_delay,&LogWindow::Timer,false);
 	//AH Changed End
	input_id = 0;
	return false; // nicht fortsetzen
}
	

LogWindow::LogWindow(int filedes): 
	Dialog<LogWindow,bool>(this),
	wrapper(this),
	input_id(0),
	timer_id(0),
	w(0),
	istr(filedes),
	fd(filedes),
	auto_scroll_down(true)
{
	fcntl(fd,F_SETFL,O_NONBLOCK);
 	//AH Changed Start => & LogWindow::
 	input_id = wrapper.InputCB(fd,XtInputReadMask,&LogWindow::Input,false);
 	//AH Changed End
}
	

LogWindow::LogWindow(char* filename): 
	Dialog<LogWindow,bool>(this),
	wrapper(this),
	input_id(0),
	timer_id(0),
	w(0),
	istr(filename),
	fd(istr ? istr.rdbuf()->fd() : -1),
	auto_scroll_down(true)
{
	if (fd>=0)
	{
		fcntl(fd,F_SETFL,O_NONBLOCK);
 		//AH Changed Start => &LogWindow::
 		input_id = wrapper.InputCB(fd,XtInputReadMask,&LogWindow::Input,false);
 		//AH Changed End
	}
	else
		text = Text("File ")+filename+" not found!\n";
}

	
LogWindow::~LogWindow()
{
	UncatchDestroy(&w);
	if (input_id) wrapper.RemoveCB(input_id);
	if (timer_id) wrapper.RemoveCB(timer_id);
}


void LogWindow::Open(char* name, char* title, Widget parent, char* buttons)
{
	if(*this) return;
 	//AH Changed => &LogWindow::
 	Create(name,title,parent,false, &LogWindow::DialogCB, buttons);
 	//AH Changed End
	scroll = XtVaCreateManagedWidget("LogWindowScroll",
		xmScrolledWindowWidgetClass,Widget(*this),NULL);

	w = XtVaCreateManagedWidget("LogWindowText",xmTextWidgetClass,scroll,
		XmNeditable,False,
		XmNeditMode,XmMULTI_LINE_EDIT,
		NULL);
	CatchDestroy(&w);
 	//AH Changed Start  .to_bool() .to_charPtr()
 	if (text.to_bool()) XmTextSetString(w,text.to_charPtr());
 	//AH Changed End
	Manage();
}
  

void LogWindow::SetContents(char* c) 
{ 
  text = c; 
  if (c) XmTextSetString(w, c);
  else XmTextSetString(w, "");
} 
