#include "scope.h"

void Scope::Skip()
{
	char c = 0;
	if (field==0)
	{
		if (is>>c && (c=='{' || c=='(' || c=='['))
			goto _here;
		else
		{
			if (minf==0)
				is.putback(c);
			else
				cerr<<"open brace expected!"<<endl;
			field = -1;
			return;
		}
	}

	_here:
	int bcnt = 1;
	while (is>>c)
		switch (c)
		{
			case '{':
			case '(':
			case '[':
				bcnt++;
				break;				
			case '}':
			case ')':
			case ']':
				if (--bcnt==0)
				{
					field = -1;
					return;
				}
		}
	field = -1;
}


bool Scope::Get()
{
	if (field==-1) return false;
	char c = 0;
	if (field++==0)
	{
		if (is>>c && (c=='{' || c=='(' || c=='['))
			goto _first_jmp;
		else
			if (minf==0)
			{
				is.putback(c);
				return false;
			}
			else
				cerr<<"open brace expected!"<<endl;
	}
	else if (is>>c)
		switch (c)
		{
			case ',':
			case ';':
				if (maxf && field>maxf)
				{
					cerr<<"close brace expected!"<<endl;
					break;
				}
			_first_jmp:
				if (is>>c)
				{
					if (c!='}' && c!=')' && c!=']')
					{
						is.putback(c);
						return true;
					}
				}
				else return is.good();
				// fall thru

			case '}':
			case ')':
			case ']':
				if (field<minf)
					cerr<<minf<<" fields expected!"<<endl;
				else
				{
					field = -1;
					return false;
				}

			default:
				cerr<<"unexpected character '"<<c<<"'!"<<endl;
		}
	else
		cerr<<"unexpected eof!"<<endl;

	is.clear(ios::badbit);
	return false;
}


bool Scope::GetId(Ident& id)
{
	if (Get())
	{
		if (is>>id)
		{
			char c;
			if (is>>c && c=='=')
				return true;
			else
			{
				cerr<<" = expected!"<<endl;
//				while (is>>c) cout<<c<<flush;
			}
		}
		is.clear(ios::badbit);
	}

	return false;
}


