// File    pvm3cpp.h      (Public C++ Header)
// Library PVM3CPP.       (C++ Extension to PVM3.4)
/**
 *         A C++ interface to PVM.
 *
 * This library is intended as an easy-to-use C++ interface to the
 * parallel virtual machine system PVM.
 * 
 *@author  Philipp Berndt
 *@version 1.0
 *@pkgdoc  pvm3cpp
 */

#ifndef PVM3CPP_H
#define PVM3CPP_H

#include "pvm3wrap.h"
#include "pvm_util.h"
#include "HostConfig.h"
#include "tnet_util.h"

using namespace P3PP;

#endif
