#ifndef __HERMITE2_H__
#define __HERMITE2_H__

INTMATRIX *LLLHermite2(INTMATRIX *DD, INTMATRIX **Aptr, USI m1, USI n1, int *rank);
/* 
 * Input: an m x n matrix DD of MPI's.
 * Output: *Aptr = HNF(DD). Also we return a small transformation matrix B
 * if nullity > 0.
 * The limiting form of  LLL applied to [I_m|N^mD_1|N^{m-1}D_2|...] is used.
 * Normally m1/n1 = 3/4.
 * 23/2/97.
 */



#endif
