#ifndef __STRUCT_IO_H__
#define __STRUCT_IO_H__
#include "matrix.h"
#include "netio.h"
#include "struct_types.h"

/*returns the [row, col]-value of a sparse-matrix.  */	
int sp_access(sp_place **matrix, int sp_row, int sp_col);
/*writes newvalue to the [row, col]-value of a sparse-matrix.   */	
void sp_input(sp_place **matrix, int sp_row, int sp_col, int newvalue);
/*writes newvalue to the [row, col]-value of a sparse-matrix.*/	
void sp_input(sp_place **matrix, int sp_row, int sp_col, int newvalue);
/*converts place matrix to integer matrix*/
INTMATRIX *conv_matrix(sp_place **mat);
/* config_arcs: convert arc format*/
int config_arcs(NetDescr *net, int i, int type);
/* config_net: convert from netio-dataformat to local format */
int config_net(NetDescr *net);
void generate_pmf(char *filename, NetDescr *net);
void read_net(char *filename);
/*	deter_in reads information about determining places from a file */
void deter_in(FILE	*f, int	**p);
/*	read_info reads additional informations about marking dependent net parts */
void read_info(FILE	*inf);

#endif
